%
% FMMA/CRC Book/JRR/JS/ExampSolSW\Example 6.2Dryden
function [Cx,Cz,Cm,qbar]  = coefficients(xta,xturb,de)

Parameters

rho     = 0.9077;   % air density at mean sea level

u       = xta(1);
w       = xta(2);
q       = xta(3);

uturb   = xturb(1);
wturb   = xturb(2);
qturb   = xturb(3);

ut      = u-uturb;
wt      = w-wturb;
qt      = q-qturb;

Vt      = sqrt(ut^2+wt^2);
qbar    = (1/2)*rho*Vt^2; 
alpha   = atan2(wt,ut);

Cx      = Cx0 + (Cxalpha*alpha) + (Cxalpha2 * alpha^2);
Cz      = Cz0 + (Czalpha*alpha) + (Czq*((qt*cbar)/(2*Vt))) + (Czde *de);
Cm      = Cm0 + (Cmalpha*alpha) + (Cmalpha2 * alpha^2) + (Cmq*((qt*cbar)/(2*Vt))) + (Cmde*de);

	