%
% FMMA CRC Book/JRR/JS/ExampSolSW\Example 6.2Dryden
function xp = state_turb(x,xu,xw,Vt,Lu,Lw,sgt,b,T)

% turbulence state
yu = x(1);yq = x(2);yw1 = x(3);yw2 = x(4);

%-----time constant------%
tu = Lu/Vt;
tw = Lw/Vt;
ku = sqrt(2*sgt^2*tu/pi);
kw = sqrt(2*sgt^2*tw/pi);
%------------------------%

% turbulence velcoity in flight path
wfturb = kw*((yw2/tw) + sqrt(3)*yw1)/tw;


% state derivative
xp(1) = (-yu + xu*ku*sqrt(pi/T))/tu;
xp(2) = -(pi*Vt/(4*b))*yq + wfturb;
xp(3) = -(yw2/tw^2)-(2*yw1/tw) + xw*sqrt(pi/T);
xp(4) = yw1;



