%
% FMMA CRC Book/JRR/JS/ExampSolSW\Example 6.2Dryden
function [ufturb,wfturb,qfturb,uturb,wturb,qturb]= turbVel(x,xp,Vt,Lu,Lw,sgt,b,alpha)

% turbulence state
yu = x(1);yq = x(2);yw1 = x(3);yw2 = x(4);
%derivative of yq
yqd= xp(2);

% turbulence velocity in flight path

%-----time constant------%
tu = Lu/Vt;
tw = Lw/Vt;
ku = sqrt(2*sgt^2*tu/pi);
kw = sqrt(2*sgt^2*tw/pi);
%------------------------%

ufturb = yu;
wfturb = kw*((yw2/tw) + sqrt(3)*yw1)/tw;
qfturb = pi*yqd/(4*b);

% conversion from flight path to body axes

dcm = [cos(alpha)  0 -sin(alpha)
       0           1  0    
       sin(alpha)  0  cos(alpha)];
   
tt = dcm * [ufturb wfturb qfturb]';

uturb = tt(1);
wturb = tt(2);
qturb = tt(3);  