%
% FMMA CRC Book/JRR/JS/ExampSolSW\Example 8.5KF
%   this file name is main.m 
%   MATLAB script to execute SFDIA
clc
disp('-----------------------------------------------------------')
disp('Sensor Fault Detection, Isolation and Reconfiguration')
disp('Using Model Based Approach - Kalman Filter')
disp('For Longitudinal Motion of an Aircraft')
disp('-----------------------------------------------------------')
clear all
close all
disp('Please Hit to Continue...')
pause

% Without sensor fault reconfiguration

rflag=0;
SFDIA
xest1=xest;
res1 = res;
Sb1  = Sb;
beta1=beta;
betas1=betas;

% With sensor fault reconfiguration

rflag=1;
SFDIA
xest2=xest;
res2 = res;
Sb2  = Sb;
beta2=beta;
betas2=betas;
%----------------------------
% plots
%----------------------------
str={'u(m/s)' 'w(m/s)' 'q(rad/s^2)' '\theta(rad)'};
% figure(1)
% for k=1:4
%     subplot(2,2,k)
%     plot(time,xt(:,k),'k')
%     hold on
%     plot(time,Zm(:,k),':k','linewidth',2)
%     plot(time,xest1(:,k),'-sk','MarkerSize',2)  
%     plot(time,xest2(:,k),'-dk','MarkerSize',2)
%     if k==1 legend('true','meas.','est.-without SFDIA','est.-with SFDIA',0); end
%     if k==3 || k==4
%         xlabel('Time [sec]')
%     end
%     ylabel(str(k))    
% end
figure(1)
for k=3:3
%    subplot(2,2,k)
    plot(time,xt(:,k),'k')
    hold on
    plot(time,Zm(:,k),':k','linewidth',2)
    plot(time,xest1(:,k),'-sk','MarkerSize',2)  
    plot(time,xest2(:,k),'-dk','MarkerSize',2)
    grid on
    if k==3 legend('true','meas.','est.-without SFDIA','est.-with SFDIA',0); end
    if k==3 || k==4
        xlabel('Time [sec]')
    end
    ylabel(str(k))    
end

figure(2)
plot(time,beta1,'-sk','MarkerSize',2)
hold on
plot(time,beta2,'-dk','MarkerSize',2)
plot(time,ChiTh*ones(N,1),'--k','linewidth',4)
title('Fault Detection Output')
grid
legend('without SFDIA','with SFDIA','threshold',0)
ylabel('Statistical Function (\beta)')
xlabel('Time [sec]')

figure(3)
for k=1:4
    subplot(2,2,k)
    plot(time,res1(:,k),'-sk','MarkerSize',2)
    hold on
    plot(time,res2(:,k),'-dk','MarkerSize',2)
    if k==1 legend('residual.-without SFDIA','residual-with SFDIA',0); end
    plot(time,Sb1(:,k),'-sk','MarkerSize',2)
    plot(time,-Sb1(:,k),'-sk','MarkerSize',2)
    plot(time,Sb2(:,k),'-dk','MarkerSize',2)
    plot(time,-Sb2(:,k),'-dk','MarkerSize',2)
    if k==3 || k==4
        xlabel('Time [sec]')
    end
    ylabel(str(k))    
    grid
end

str={'\beta-u' '\beta-w' '\beta-q' '\beta-\theta'};

% figure(4)
% for k=1:4
%     subplot(2,2,k)
%     plot(time,betas1(:,k),'-sk','MarkerSize',2)
%     hold on
%     plot(time,betas2(:,k),'-dk','MarkerSize',2)
%     plot(time,ChiThs*ones(N,1),'--k','linewidth',4)
%     if k==1 legend('without SFDIA','with SFDIA','thershold',0);end
%     if k==3 || k==4
%         xlabel('Time [sec]')
%     end
%     ylabel(str(k))
%     grid
% end     
        