%
%FMMA CRC BOOK/JRR/JS/ExampSolSW\Example 9.2ANFISPEstm
clc
disp('-----------------------------------------------------------')
disp('Parmeter Estimation')
disp('Using Non-Model Based Approach - ANFIS')
disp('For system : see simu.m')
disp('-----------------------------------------------------------')
clear all
close all
disp('Please Hit to Continue...')
pause

format long

%-------------Data simulation--------------%
                simu
%------------------------------------------%

%------------------------------------------%
% data format (o-output//i-input) %
% columns:  1   2   3  
% i/o       o   i   i   
% variables y   u1 u2
%------------------------------------------%

ic = [2,3];                 % input columns
oc = [1];                   % output columns
% 

%-------------true parameters--------------%
betat = [b c a];
%------------------------------------------%

[dum,np] =  size(betat);      % np = number of parameters to be estimated
pertb    = [0.0001 0.0001];   % input perturbation 
z        = data(:,oc);        % output data
u        = data(:,ic);        % input data

% ---------Training FIS using ANFIS--------%

totData  = [u z]; 
ototData = totData;

[samples,oindx]=size(totData);

trnData = totData;          % training data
chkData = totData;          % check data

fismat1 = genfis1(trnData,[2 3],char('gbellmf','gbellmf'),'linear'); % Good training parameters


% training parameters

TRNOPT(1)= 10;         %: training epoch number                     (default: 10)
TRNOPT(2)= 0;          %: training error goal                       (default: 0)
TRNOPT(3)= 0.01;       %: initial step size                         (default: 0.01)
TRNOPT(4)= 0.9;        %: step size decrease rate                   (default: 0.9)
TRNOPT(5)= 1.1;        %: step size increase rate                   (default: 1.1)

[d1,d2,d3,fismat1,err1] = anfis(trnData,fismat1,TRNOPT,[],chkData,1);


% Parameter estimation

FLAG = 1;
fid = 1111;
[dum,li]=size(ic);
[dum,lo]=size(oc);
lio = li+lo;

while FLAG
    if fid == 5
        close(fid);
    end
    snr = 100 ;
    stdsig=std(totData(:,1:np-1));
    sigma=stdsig/sqrt(snr);
    v=noise_gen(samples,1111,li);
    for i=1:samples
        for j=1:li
            v(i,j)       = sigma(j)*v(i,j);
            totData(i,j) = totData(i,j) + v(i,j);
        end
        totData(i,3) = a + b*totData(i,1)+c*totData(i,2); 
    end
   
    % without perturbation
    
    for i=1:samples
            anfis_output_1(i,1) = evalfis(totData(i,1:np-1), fismat1);
    end
       
    % positive perturbation
    for pindx = 1:np-1
        for i=1:samples
            u = totData(i,1:np-1);
            u(pindx) = totData(i,pindx) + pertb(pindx);
            anfis_output_2(pindx,i,1) = evalfis(u, fismat1);
        end
    end
        
    % negative perturbation
    for pindx = 1:np-1
        for i=1:samples
            u = totData(i,1:np-1);
            u(pindx) = totData(i,pindx) - pertb(pindx);
            anfis_output_3(pindx,i,1) = evalfis(u, fismat1);
        end
    end

    % parameter estimation 
    % for varying
     for pindx = 1:np-1
        for i=1:samples
            betae(pindx,i,1) = (anfis_output_2(pindx,i,1)-anfis_output_3(pindx,i,1))/(2*pertb(pindx));
        end
     end
     
    % for constant
     for j=1:samples
         sum1 = 0;
         for i = 1:np-1
             sum1 = sum1 + (betae(i,j,1)*totData(j,i));
         end
         betae(np,j,1) =  anfis_output_1(j,1)- sum1;
     end
     for i=1:np
         tmp(i,1) = mean(betae(i,:,1));
     end
    
    [nrr,ncc]=size(betat);
    betatrue=[betat(ncc) betat(1:ncc-1)];
    
    t1 = tmp(:,1)';
    [nrr,ncc]=size(t1);    
    t1 =[t1(ncc) t1(1:ncc-1)];
    
    beta = [betatrue;t1]; 
    peen(1) = 100*(norm(betatrue-t1))./(norm(betatrue));

    clc
    disp('---------------------------------------------------')
    disp(strcat('Parameters true/estimated: ',num2str(beta')))
    disp(strcat('PEEN: ',num2str(peen)))
    disp('---------------------------------------------------')

    
    figure(1)
    subplot(211)
    plot(y,'k')
    hold on;grid on
    plot(anfis_output_1(:,1),'.-k')
    ylabel('y')
    legend ('True','ANFIS-grid partition')
    axis tight
    subplot(212)
    plot(y'-anfis_output_1(:,1),'--k')
    hold on;grid on
    xlabel('Data points')
    ylabel('prediction error')
    axis tight     
    FLAG = 0;    
end
