%
% FMMA CRC BOOK/JRR/JS/ExampSolSW\Example 9.3AKF
clear
clc
close all
clc
disp('------------------------------------------------------------------')
disp('Fuzzy Kalman Filter for tracking manuevering target along x-y axes')
disp('Target model : Constant acceleration (Evasive maneuver)')
disp('Comparison with KF and Adaptive (Maybeck) KF')
disp('------------------------------------------------------------------')
clear all
close all
disp('Please Hit to Continue...')
pause

N  = 17;
st = 8; 
ep = 15;

T  = 1;
ns = 6;
Xt = [100 30 0 100 20 0];

Q  = [0.1 0   
      0   0.1]; 
seedNo = [1234 4321];

for j=1:2
    w(:,j)  = sqrt(Q(j,j))*noise_gen(N,seedNo(j),1);   
end
  
g=1;
xacc = 6*g;
yacc = -6*g;

F1 = [1 T T^2/2
      0 1 T
      0 0 1];
F  = [F1 zeros(3,3);zeros(3,3) F1]; 

G1 = [T^2/2 T 1];
G = [G1 zeros(1,3);zeros(1,3) G1]';

for k=1:N-1
    if k==st
        w(k,1) = w(k,1)+xacc;
        w(k,2) = w(k,2)+yacc;
    end
    if k==ep
        w(k,1) = w(k,1)-xacc;
        w(k,2) = w(k,2)-yacc;
    end    
    Xt(k+1,:)=(F*Xt(k,:)' + G*w(k,:)')';
end

R = [25 0 
     0  25];
H = [1 0 0 0 0 0;0 0 0 1 0 0]; 
for k=1:N
    time(k) = (k-1)*T;
    Zt(k,:) = (H*Xt(k,:)')';   
end
fismat2 = readfis('fsc.fis');
fis(1)=fismat2;
fis(2)=fismat2;

% adative Q related parameters
WL = 5;

M=10;
for m=1:M
    disp(strcat('Monte-Carlo No.:',num2str(m)));
    seedNo = [7453+m 8657+m];
    for j=1:2
        v(:,j)  = sqrt(R(j,j))*noise_gen(N,seedNo(j),1);   
    end
    for k=1:N
        Zm(k,:) = Zt(k,:)+ v(k,:);
    end
    Xhat1 = Xt(1,:);
    Phat1 = eye(6);
%     Xhat1 = 0.9*Xt(1,:);
%     Phat1 = diag((Xt(1,:)-Xhat1).^2);%eye(6);
    Xhat2 = Xhat1;
    Phat2 = Phat1;
    Xhat3 = Xhat1;
    Phat3 = Phat1;
    
    Nu3   = Zm(1,:)'-H*Xhat3';
    dxx(1,:) = Nu3';
    
    Nu2  = Zm(1,:)'-H*Xhat2';

    Xe1(m,1,:) = Xhat1;
    Xe2(m,1,:) = Xhat2;
    Xe3(m,1,:) = Xhat3;
    
    stb1(m,1,:) = sqrt(diag(Phat1)');
    stb2(m,1,:) = sqrt(diag(Phat2)');
    stb3(m,1,:) = sqrt(diag(Phat3)');
    Q1 = Q;
    for k=1:WL-1
        Qs(m,k,:)=diag(Q1)';
    end

    for k=2:N
        
        [Xhat1,Phat1,S1,Nu1,K1] = kf(Xhat1,F,H,Zm(k,:),Phat1,Q,R,G);            
        Xe1(m,k,:) = Xhat1; stb1(m,k,:) = sqrt(diag(Phat1)');
        
        [Xhat2,Phat2,S2,Nu2,Ck] = fkf(Xhat2,F,H,Zm(k,:),Phat2,Q,R,G,fis,Nu2,T);
        Xe2(m,k,:) = Xhat2; stb2(m,k,:) = sqrt(diag(Phat2)');
        
        [Xhat3,Phat3,S3,Nu3,K3] = kf(Xhat3,F,H,Zm(k,:),Phat3,Q1,R,G);            
        Xe3(m,k,:) = Xhat3; stb3(m,k,:) = sqrt(diag(Phat3)');

        dxx(k,:) = Nu3';
        % adative Q estimation using maybeck method - steady state
        if k >= WL   
           a_cap = 0;
           for j=k-WL+1:k
            a_cap = a_cap + dxx(j,:)'*dxx(j,:);
           end
           Qest = maybeckQ_ss(F,G,H,K3,a_cap/WL,ns);
           Q1   = diag(diag(Qest)); 
           Qs(m,k,:)=diag(Q1)';           
        end
    end
end

% mean computation
[dum,sz,dum]=size(Xe1);
Xe1        = reshape(mean(Xe1),sz,6);
Xe2        = reshape(mean(Xe2),sz,6);
Xe3        = reshape(mean(Xe3),sz,6);
Qs         = reshape(mean(Qs),sz,2);

for k=1:sz
    rsspe(k,1) = sqrt((Xt(k,1)-Xe1(k,1))^2 + (Xt(k,4)-Xe1(k,4))^2); 
    rsspe(k,2) = sqrt((Xt(k,1)-Xe2(k,1))^2 + (Xt(k,4)-Xe2(k,4))^2); 
    rsspe(k,3) = sqrt((Xt(k,1)-Xe3(k,1))^2 + (Xt(k,4)-Xe3(k,4))^2); 

    rssve(k,1) = sqrt((Xt(k,2)-Xe1(k,2))^2 + (Xt(k,5)-Xe1(k,5))^2); 
    rssve(k,2) = sqrt((Xt(k,2)-Xe2(k,2))^2 + (Xt(k,5)-Xe2(k,5))^2); 
    rssve(k,3) = sqrt((Xt(k,2)-Xe3(k,2))^2 + (Xt(k,5)-Xe3(k,5))^2); 

    rssae(k,1) = sqrt((Xt(k,3)-Xe1(k,3))^2 + (Xt(k,6)-Xe1(k,6))^2); 
    rssae(k,2) = sqrt((Xt(k,3)-Xe2(k,3))^2 + (Xt(k,6)-Xe2(k,6))^2); 
    rssae(k,3) = sqrt((Xt(k,3)-Xe3(k,3))^2 + (Xt(k,6)-Xe3(k,6))^2); 
end

figure(1)
plot(Zm(:,1)/1000,Zm(:,2)/1000,':k')
hold on;grid on
plot(Xt(:,1)/1000,Xt(:,4)/1000,'k','LineWidth',2)
plot(Xe1(:,1)/1000,Xe1(:,4)/1000,'-sk','MarkerSize',4)
plot(Xe2(:,1)/1000,Xe2(:,4)/1000,'-dk','MarkerSize',6)
plot(Xe3(:,1)/1000,Xe3(:,4)/1000,'-ok','MarkerSize',4)
xlabel('x-pos (Km)')
ylabel('z-pos (Km)')
legend('meas.','true','Kalman Filter','Fuzzy Kalman Filter','Adaptive Kalman Filter',0)

figure(2)
plot(time,rsspe(:,1)/1000,'-sk','MarkerSize',4)
hold on;grid on
plot(time,rsspe(:,2)/1000,'-dk','MarkerSize',6)
plot(time,rsspe(:,3)/1000,'-ok','MarkerSize',4)
xlabel('Time [sec]')
ylabel('rsspe (km)')
legend('Kalman Filter','Fuzzy Kalman Filter','Adaptive Kalman Filter',0)
