%
%FMMA CRC BOOK/JRR?JS/ExampSolSW\Example 9.3FKTT4Rules
% Building Fuzzy Inference System (FIS) for fuzzy state correlator 
% used in Kalman filter 
% inputs : ex = innovation sequence, d_ex = (ex - past_ex)/timestep
% output : correction vector Ck 

function a = bldfiskf(fisname,R)

ex_min = -sqrt(R);
ex_max = sqrt(R);

L1  = -Inf;
L2  = -(100/100)*sqrt(R);
L3  = -(18/100)*sqrt(R);
L4  = 0*-(10/100)*sqrt(R);
L5  = -(2/100)*sqrt(R);
L6  = 0;
L7  = -L5;
L8  = -L4;
L9  = -L3;
L10 = -L2;
L11 = -L1;

a = newfis(fisname);
a.input(1).name  = 'ex';
a.input(1).range = [ex_min ex_max];
a.input(1).mf(1).name = 'LN';
a.input(1).mf(1).type = 'trapmf';
a.input(1).mf(1).params = [L1 L2 L3 L4];
% a.input(1).mf(2).name = 'MN';
% a.input(1).mf(2).type = 'trimf';
% a.input(1).mf(2).params = [L3 L4 L5];
% a.input(1).mf(3).name = 'SN';
% a.input(1).mf(3).type = 'trimf';
% a.input(1).mf(3).params = [L4 L5 L6];
% a.input(1).mf(4).name = 'ZE';
% a.input(1).mf(4).type = 'trimf';
% a.input(1).mf(4).params = [L5 L6 L7];
% a.input(1).mf(5).name = 'SP';
% a.input(1).mf(5).type = 'trimf';
% a.input(1).mf(5).params = [L6 L7 L8];
% a.input(1).mf(6).name = 'MP';
% a.input(1).mf(6).type = 'trimf';
% a.input(1).mf(6).params = [L7 L8 L9];
a.input(1).mf(2).name = 'LP';
a.input(1).mf(2).type = 'trapmf';
a.input(1).mf(2).params = [L8 L9 L10 L11];

dex_min = (20/100)*(ex_min);
dex_max = (20/100)*(ex_max);

L1  = -Inf;
L2  = -(20/100)*sqrt(R);
L3  = -(1.8/100)*sqrt(R);
L4  = 0*-(0.6/100)*sqrt(R);
L5  = -(0.2/100)*sqrt(R);
L6  = 0;
L7  = -L5;
L8  = -L4;
L9  = -L3;
L10 = -L2;
L11 = -L1;

a.input(2).name  = 'd_ex';
a.input(2).range = [dex_min dex_max];
a.input(2).mf(1).name = 'LN';
a.input(2).mf(1).type = 'trapmf';
a.input(2).mf(1).params = [L1 L2 L3 L4];
% a.input(2).mf(2).name = 'MN';
% a.input(2).mf(2).type = 'trimf';
% a.input(2).mf(2).params = [L3 L4 L5];
% a.input(2).mf(3).name = 'SN';
% a.input(2).mf(3).type = 'trimf';
% a.input(2).mf(3).params = [L4 L5 L6];
% a.input(2).mf(4).name = 'ZE';
% a.input(2).mf(4).type = 'trimf';
% a.input(2).mf(4).params = [L5 L6 L7];
% a.input(2).mf(5).name = 'SP';
% a.input(2).mf(5).type = 'trimf';
% a.input(2).mf(5).params = [L6 L7 L8];
% a.input(2).mf(6).name = 'MP';
% a.input(2).mf(6).type = 'trimf';
% a.input(2).mf(6).params = [L7 L8 L9];
a.input(2).mf(2).name = 'LP';
a.input(2).mf(2).type = 'trapmf';
a.input(2).mf(2).params = [L8 L9 L10 L11];

Ckx_min = (3/100)*(ex_min);
Ckx_max = (3/100)*(ex_max);

L1  = -Inf;
L2  = -(3/100)*sqrt(R);
L3  = -(2.7/100)*sqrt(R);
L4  = 0*-(0.91/100)*sqrt(R);
L5  = -(0.3/100)*sqrt(R);
L6  = 0;
L7  = -L5;
L8  = -L4;
L9  = -L3;
L10 = -L2;
L11 = -L1;

a.output(1).name = 'Ckx';
a.output(1).range = [Ckx_min Ckx_max];
a.output(1).mf(1).name = 'LN';
a.output(1).mf(1).type = 'trapmf';
a.output(1).mf(1).params = [L1 L2 L3 L4];
% a.output(1).mf(2).name = 'MN';
% a.output(1).mf(2).type = 'trimf';
% a.output(1).mf(2).params = [L3 L4 L5];
% a.output(1).mf(3).name = 'SN';
% a.output(1).mf(3).type = 'trimf';
% a.output(1).mf(3).params = [L4 L5 L6];
a.output(1).mf(2).name = 'ZE';
a.output(1).mf(2).type = 'trimf';
a.output(1).mf(2).params = [L5 L6 L7];
% a.output(1).mf(5).name = 'SP';
% a.output(1).mf(5).type = 'trimf';
% a.output(1).mf(5).params = [L6 L7 L8];
% a.output(1).mf(6).name = 'MP';
% a.output(1).mf(6).type = 'trimf';
% a.output(1).mf(6).params = [L7 L8 L9];
a.output(1).mf(3).name = 'LP';
a.output(1).mf(3).type = 'trapmf';
a.output(1).mf(3).params = [L8 L9 L10 L11];

% add rulelist

% ruleList = [1 1 1 1 1
%             1 2 1 1 1
%             1 3 2 1 1
%             1 4 2 1 1
%             1 5 2 1 1
%             1 6 3 1 1
%             1 7 4 1 1
%             
%             2 1 1 1 1
%             2 2 2 1 1
%             2 3 2 1 1
%             2 4 2 1 1
%             2 5 3 1 1
%             2 6 4 1 1
%             2 7 5 1 1
%             
%             3 1 2 1 1
%             3 2 2 1 1
%             3 3 2 1 1
%             3 4 3 1 1
%             3 5 4 1 1
%             3 6 5 1 1
%             3 7 6 1 1
%             
%             4 1 2 1 1
%             4 2 2 1 1
%             4 3 3 1 1
%             4 4 4 1 1
%             4 5 5 1 1
%             4 6 6 1 1
%             4 7 6 1 1
%             
%             5 1 2 1 1
%             5 2 3 1 1
%             5 3 4 1 1
%             5 4 5 1 1
%             5 5 6 1 1
%             5 6 6 1 1
%             5 7 6 1 1
%             
%             6 1 3 1 1
%             6 2 4 1 1
%             6 3 5 1 1
%             6 4 6 1 1
%             6 5 6 1 1
%             6 6 6 1 1
%             6 7 7 1 1
%             
%             7 1 4 1 1
%             7 2 5 1 1
%             7 3 6 1 1
%             7 4 6 1 1
%             7 5 6 1 1
%             7 6 7 1 1
%             7 7 7 1 1];
ruleList = [1 1 1 1 1
            1 2 2 1 1
            2 1 2 1 1
            2 2 3 1 1];
        
a = addrule(a,ruleList);

 


