%
% FMMA CRC BOOK/JRR/JS/ExampSolSW\Example 9.4DFKF
function [XsigmaPoints,Wm,Wc,npts] = createSigmaPoints(Xhat_a,Phat_a,alpha,beta,kappa)

L     = length(Xhat_a);         % dimension of augmented state
lemda = alpha^2*(L+kappa)-L;    % composite scaling parameter
npts  = 2*L+1;                  % number of sigma points

XsigmaPoints = zeros(L,npts);

% Calculate matrix square root of weighted covariance matrix
Psqrtm =(chol((L+lemda)*Phat_a))';  

% Array of the sigma points
XsigmaPoints = [zeros(size(Phat_a,1),1) -Psqrtm Psqrtm];

% Add mean back in
XsigmaPoints = XsigmaPoints + repmat(Xhat_a',1,npts);
XsigmaPoints = XsigmaPoints'; % to get dimension (npts by L) 

[Wm,Wc]      = createSigmaWeights(L,npts,lemda,alpha,beta);
