%
%FMMA CRC BOOK/JRR/JS/ExampSolSW\Example 9.4DFKF
% Extended UD Kalman filter

function [Xhat,udf,S,Nu] = eudkf(Xhat,udf,G,Q,R,T,ym,u,xi,yi,zi,eps,nx,nw,ny)

n = nx + nw;

%delx   =  eps*Xhat;
delx   =  1.0d-4*ones(1,nx);

A      =  jstatelin(nx,ny,Xhat,u(1),u(2),u(3),u(4),u(5),u(6),delx);
F      =  eye(nx)+A*T+A^2*T^2/2+(A^3)*(T^3)/(3*2)+(A^4)*(T^4)/(4*3*2)+(A^5)*(T^5)/(5*4*3*2)+(A^6)*(T^6)/(6*5*4*3*2)+(A^7)*(T^7)/(7*6*5*4*3*2)+(A^8)*(T^8)/(8*7*6*5*4*3*2);
Xtelda =  rk4int(Xhat,T,u(1),u(2),u(3),u(4),u(5),u(6),nx);

for i=nx+1:n
    d(i)=Q(i-nx,i-nx); 
end

for j=nx:-1:2
    for i=1:j
        d(i)=udf(i,j);
    end
    for i=1:nx
        udf(i,j)=F(i,j);
        for k=1:j-1
            udf(i,j)=udf(i,j)+F(i,k)*d(k);
        end
    end
end
d(1)=udf(1,1);
for j=1:nx 
    udf(j,1)=F(j,1);
end

% ud time update
udf=udtpf(nx,nw,udf,d);
for i=1:nx
    for j=1:nw
        udf(i,nx+j)=G(i,j);
    end
end

yy   = meas(Xtelda,xi,yi,zi,u);
Nu   = ym-yy';
Phat = ud2P(udf);
H    = jmeaslin(Xtelda,xi,yi,zi,u,delx,nx,ny);
S    = H*Phat*H' + R;

% measurement update
for j=1:ny
    cr= R(j,j);
    H = jmeaslin(Xtelda,xi,yi,zi,u,delx,nx,ny);
    cz=ym(j);
    for i=1:nx
        c(i)=H(j,i);
    end
   yy = meas(Xtelda,xi,yi,zi,u);
   zp=yy(j);
   ze=cz-zp;
   [udf,Xtelda] = udmpr(Xtelda,udf,c,cr,ze,nx); 
end
Xhat = Xtelda;

