%
% FMMA CRC BOOK/JRR/JS/ ExampSolSW\Example 9.4DFKF
% udmpr.m//UD measurement update
% for kinematic models 
% x=estimated state;b=kalman gain;udf =updated ud matrix
% function [udf,xte]=gkudmpr(xte,udf,c,cr,cz,nx)
% the measurements are processed one at a time - scalar processing

function [udf,xte]=udmpr(xet,udf,c,cr,cz,nx)
for j=nx:-1:2
    for k=1:j-1
        c(j)=c(j)+udf(k,j)*c(k);
    end
    b(j)=udf(j,j)*c(j);
end
b(1)=udf(1,1)*c(1);
alpha=cr+b(1)*c(1);
if alpha == 0
    alpha = 1.0e-20;
end
gamma=1.0/alpha;
udf(1,1)=cr*gamma*udf(1,1);
for j=2:nx
    beta=alpha;
    alpha=alpha+b(j)*c(j);
    if alpha == 0
        alpha = 1.0e-20;
    end
    lambda=-c(j)*gamma;
    gamma=1.0/alpha;
    udf(j,j)=beta*gamma*udf(j,j);
    for i=1:j-1
        beta=udf(i,j);
        udf(i,j)=beta+b(i)*lambda;
        b(i)=b(i)+b(j)*beta;
    end
end
cz=cz*gamma;
for i=1:nx
    xte(1,i) = xet(1,i) + b(i)*cz;
end

% END OF THE FILE