%
% FMMA CRC BOOK/JRR/JS/ExampSolSW\Example 9.4DFKF
% ud time updating for kinematic consistency
% function [udf]=gkudtpf(nx,ns,udf,d)
% computes the u,d factors of the process covariance matrix
% given the apriori u,d factors 
function [udf]=udtpf(nx,ns,udf,d)

n=nx+ns;
v(1)=0;
for j=nx:-1:1
    sig=0.0;
    for k=1:n
        v(k)=udf(j,k);
        a(k)=d(k)*v(k);
        sig=sig+v(k)*a(k);
    end
    if sig == 0
        sig = 1.0e-20;
    end
    udf(j,j)=sig;
    if j~=1
        dinv=1.0/sig;
        jm1=j-1;
        for k=1:jm1
            sig=0;
            for i=1:n
                sig=sig+udf(k,i)*a(i)*dinv;
            end
            udf(j,k)=sig;
            for i=1:n
                udf(k,i)=udf(k,i)-sig*v(i);
            end
        end
    else
        %disp('end of UDTP')
    end
end
for j=2:nx
    for i=1:j-1
        udf(i,j)=udf(j,i);
        udf(j,i)=0;
    end
end

% END OF THE ROUTINE