%
% FMMA CRC BOOK/JRR/JS/ExampSolSW\Example 9.4DFKF
% Unscented Kalman filter with augmented state

function[Xhat,Phat,S,Nu] = ukf(Xhat,Phat,G,Q,R,T,Zm,u,xi,yi,zi,nx,nw,ny,alpha,beta,kappa)

%          nx  nx+1:nx+nw     nx+nw+1:nx+nw+ny
Xhat_a = [Xhat zeros(1,nw)    zeros(1,ny)];                                   % augmented state
Phat_a = [Phat zeros(nx,nw+ny);zeros(nw,nx) Q zeros(nw,ny);zeros(ny,nx+nw) R];% augmented state covariance
% Create Sigma Points & its weigths
[XsigmaPoints,Wm,Wc,npts] = createSigmaPoints(Xhat_a,Phat_a,alpha,beta,kappa);

% --------------- Time update ------------------------ 
XPredSigmaPts = feval('ffun',XsigmaPoints(:,1:nx),XsigmaPoints(:,nx+1:nx+nw),G,T,u,nx);        
ZPredSigmaPts = feval('hfun',XPredSigmaPts,XsigmaPoints(:,nx+nw+1:nx+nw+ny),xi,yi,zi,u);


% Calculate Xtelda,Ptelda, and Ztelda

Xtelda = zeros(1,nx);
Ptelda = zeros(nx);
Ztelda = zeros(1,ny);

for i=1:npts
    Xtelda = Xtelda + (Wm(i)*XPredSigmaPts(i,:));   
    Ztelda = Ztelda + (Wm(i)*ZPredSigmaPts(i,:));
end
for i=1:npts
    Ptelda = Ptelda + (Wc(i)*(XPredSigmaPts(i,:)-Xtelda)'*(XPredSigmaPts(i,:)-Xtelda));
end

% ------------------- Measurement update ----------------

Pyy = zeros(ny);
Pxy = zeros(nx,ny);

for i=1:npts
    Pyy = Pyy + (Wc(i)*(ZPredSigmaPts(i,:)-Ztelda)'*(ZPredSigmaPts(i,:)-Ztelda));
    Pxy = Pxy + (Wc(i)*(XPredSigmaPts(i,:)-Xtelda)'*(ZPredSigmaPts(i,:)-Ztelda));
end

K = Pxy*inv(Pyy);   % filter gain

Xhat = Xtelda + (K*(Zm - Ztelda)')';
Phat = Ptelda - (K*Pyy*K');

S  = Pyy;
Nu = Zm - Ztelda;
% end of program
